unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series,
  Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TLineSeries;
    Series4: TLineSeries;
    Series5: TLineSeries;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    Memo1: TMemo;
    Series6: TLineSeries;
    LabeledEdit4: TLabeledEdit;
    Series7: TLineSeries;
    Image1: TImage;
    Image2: TImage;
    CheckBox1: TCheckBox;
    LabeledEdit5: TLabeledEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    function fy: boolean;
    procedure Linedraw;
    procedure Textdraw;
    procedure area(bx, by, gx, gy: double);
    procedure second_imperfect_elliptic_integral(z, K: double; var F, E: Double);
    procedure arch(bx, gx, by, gy: double);
    procedure integral(betax, gammaX: double);
    procedure archpaint(bx, by, gx, gy: double);
    procedure Image2Draw;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses  math;

var
  a, b : double;                            // oȐW
  alpha, d : double;                        // W
  xinp     : double;                        // ̈ʒu

  xpL, xpR   : integer;
  xpF        : boolean;

procedure TForm1.Button1Click(Sender: TObject);
label
  ENDNP;
var
  ch : integer;
  chF : boolean;
begin
  button1.Enabled := False;
  chF := True;
  val(LabeledEdit1.Text, a, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lɊԈႢ܂B','',0);
    chF := False;
    goto ENDNP;
  end;
  if a = 0 then begin
    application.MessageBox('[łB','',0);
    chF := False;
    goto ENDNP;
  end;
  val(LabeledEdit2.Text, b, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lɊԈႢ܂B','',0);
    chF := False;
    goto ENDNP;
  end;
  if b = 0 then begin
    application.MessageBox('b[łB','',0);
    chF := False;
    goto ENDNP;
  end;
  if not checkBox1.Checked then begin
    val(LabeledEdit3.Text, alpha, ch);
    if ch <> 0 then begin
      application.MessageBox('̒lɊԈႢ܂B','',0);
      chF := False;
      goto ENDNP;
    end;
    val(LabeledEdit4.Text, d, ch);
    if ch <> 0 then begin
      application.MessageBox('d̒lɊԈႢ܂B','',0);
      chF := False;
    end;
  end
  else begin
    val(LabeledEdit5.Text, Xinp, ch);
    if ch <> 0 then begin
      application.MessageBox('d̒lɊԈႢ܂B','',0);
      chF := False;
    end;
  end;
ENDNP:
  if not chF then begin
    button1.Enabled := True;
    exit;
  end;
  a := abs(a);
  b := abs(b);
  fy;
  button1.Enabled := True;
end;

// |`,`̖ʐρA̕ϕmFvZ
procedure TForm1.integral(betax, gammaX: double);
var
  i, n      : integer;
  dx, dx2   : double;
  b2, b2sa2 : double;
  s, x      : double;
  x0, x1    : double;
  y0, y1    : double;
  L, dl     : double;
  ds, ss    : double;
  sl, sr, aa  : double;
begin
  memo1.Lines.Add('');
  s   := 0;
  n := 10000;                                 // 
  dx  := (gammaX - betaX) / n;                // x
  dx2 := dx / 2;                              // ԓ_ x/2
  b2 := b * b;
  b2sa2 := b * b / a / a;
  for i:= 0 to n - 1 do begin                 // ϕvZ
    x := i * dx + dx2 + betaX;
    y0 := alpha * x + d;                      // yl
    y1 := sqrt(b2 + b2sa2 * x * x);           // oȐyl
    s := s + abs(abs(y0) - y1);
  end;
  s := s * dx;
  memo1.Lines.Add('|`̖ʐρ@Su = ' + floatTostr(s));

  L := 0;                                     // ʂ̒
  x0 := betaX;                                // ŏxvZ
  y0 := sqrt(b2 + b2sa2 * x0 * x0);           // ŏyvZ
  for i := 1 to n do begin                    // ϕvZ
    x1 := i * dx + betaX;                     // oȐx
    y1 := sqrt(b2 + b2sa2 * x1 * x1);         // oȐy
    dl := sqrt((x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0));  // L
    L  := L + dl;                             // vl
    x0 := x1;
    y0 := y1;
  end;

  y0 := sqrt(b2 + b2sa2 * betaX  * betaX);    // oȐbetaẌʒuy̒l
  y1 := sqrt(b2 + b2sa2 * gammaX * gammaX);   // oȐgammaẌʒuy̒l

  dx :=  (abs(gammaX) + abs(betaX)) / n;      // x
  dx2 := dx / 2;                              // ԓ_ x/2
  sl := 0;                                    // `
  if abs(betaX) > dx then begin
    aa := abs(y0 / betaX);                    // ̌X
    for i := 0 to round(abs(betaX / dx)) - 1 do begin
      x := i * dx + dx2;
      ds := (sqrt(b2 + b2sa2 * x  * x) - aa * x) * dx;    // s
      sl := sl + ds;
    end;
  end;

  sr := 0;                                    // `
  if abs(gammaX) > dx then begin
    aa := abs(y1 / gammaX);                   // ĚX
    for i := 0 to round(abs(gammaX / dx)) - 1 do begin
      x := i * dx + dx2;
      ds := (sqrt(b2 + b2sa2 * x  * x) - aa * x) * dx;    // s
      sr := sr + ds;
    end;
  end;

  if gammaX * betaX <= 0 then aa := sl + sr
                         else aa := abs(sl - sr);

  ds := abs(betaX * y1 - gammaX * y0) / 2;    // Op`ʐ
  ss := ds - s;                               // `ʐ
  memo1.Lines.Add('`̖ʐρ@So = ' + floatTostr(aa));
  memo1.Lines.Add('`̖ʐρ@So''= ' + floatTostr(ss));
  memo1.Lines.Add('|`ʂ̒  L = ' + floatTostr(L));
end;

//-------------------------------
// PQȉ~ϕ
// FBnKn[0] Pȉ~ϕ
// EBnKn[0] Qȉ~ϕ
// fϊ
// Q px deg
// K S
//-------------------------------
procedure TForm1.second_imperfect_elliptic_integral(z, K: double; var F, E: Double);
var
  I, MI   : integer;
  Kn      : array of double;         // Kn
  knd     : array of double;         // k'n
  N2SKn   : array of double;         // 2/(1+Kn)
  T2SKnd  : array of double;         // P2/(1+Kn')
  BRad    : array of double;         // (rad)
  SinBn   : array of double;         // sinn
  FBnKn   : array of double;         // F(n,kn)
  EBnKn   : array of double;         // E(n,kn)
  LnD     : double;
  Q       : double;
begin
  // K = 0 ͉̎~Ȃ̂pi̊pxlrad܂B
  Q := arcsin(z);
  if K = 0 then begin
    E := Q;
    F := E;
    exit;
  end;
  // ̎͂P܂@ZG[h~ׁ̈Al͐܂B
  if (K = 1) and (Q >= pi / 2) then begin
    E := 1;
    F := 1;
    exit;
  end;

  // (1 > K > 0 and Q <= 90) or (K = 1 and Q < 90)̎
  MI := 0;
  LND := 0;
  setlength(kn,  MI + 1);           // kn
  kn[0] := K;
  while LND <> Kn[MI] do begin
    LnD := Kn[MI];
    inc(MI);
    setlength(kn,  MI + 1);         // kn
    kn[MI] := 2 * sqrt(Kn[MI - 1])/(1 + Kn[MI - 1]);
  end;
  Dec(MI);
  setlength(kn,      MI + 1);         // kn
  setlength(knd,     MI + 1);         // k'n
  setlength(N2SKn,   MI + 1);         // 2/(1+Kn)
  setlength(T2SKnd,  MI + 1);         // P2/(1+Kn')
  setlength(BRad,    MI + 1);         // (rad)
  setlength(SinBn,   MI + 1);         // sinn
  setlength(FBnKn,   MI + 1);         // F(n,kn)
  setlength(EBnKn,   MI + 1);         // E(n,kn)

  knd[0] := 1;
  for I := 1 to MI do
    knd[I] := (1 - kn[I - 1]) / (1 + Kn[I - 1]);
  for I := 0 to MI do
    N2SKn[I] := 2 / (1 + kn[I]);
  T2SKnd[MI] := N2SKn[MI];
  for I := MI - 1 downto 0 do
    T2SKnd[I] := T2SKnd[I + 1] * N2SKn[I];
  BRad[0] := Q;
  for I := 1 to MI do
    BRad[I] := (arcsin(kn[I - 1] * sin(Brad[I - 1])) + Brad[I - 1]) / 2;
  for I := 0 to MI do
    SinBn[I] := sin(Brad[I]);
  LnD := LN((1 + sin(Brad[MI])) / cos(Brad[MI]));
  for I := 0 to MI do
    FBnKn[I] := T2SKnd[I] * LnD;
  F := FBnKn[0];
  EBnKn[MI] := sin(Brad[MI]);
  for I := MI - 1 downto 0 do
    EBnKn[I] :=  (2 * EBnKn[I + 1] + 2 * knd[I + 1] * FBnKn[I + 1]) / (1 + knd[I + 1]) - kn[I] * SinBn[I];
  E := EBnKn[0];
end;

// oȌʂ̒vZ
procedure TForm1.arch(bx, gx, by, gy: double);
var
  e, k, z   : double;
  Fzk, Ezk  : double;
  L, Ll, Lr, x     : double;

begin
  e := sqrt(b * b + a * a) / b;                             // Se
  k := 1 / e;                                               // k

  x := abs(by);
  z := sqrt((x * x - b * b) / (x * x - k * k * b * b));     // z
  second_imperfect_elliptic_integral(z, k, Fzk, Ezk);       // ȉ~ϕ
  Ll := (b * (1 - k * k) * Fzk - b * Ezk + x * z) / k;      // Ll
  if bx > 0 then Ll := -Ll;                                 // _Ɠ̏ꍇ

  x := abs(gy);
  z := sqrt((x * x - b * b) / (x * x - k * k * b * b));     // z
  second_imperfect_elliptic_integral(z, k, Fzk, Ezk);       // ȉ~ϕ
  Lr := (b * (1 - k * k) * Fzk - b * Ezk + x * z) / k;      // Ll
  if gx < 0 then Lr := -Lr;                                 // _Ɠ̏ꍇ

  L := Ll + Lr;
  memo1.Lines.Add('|`ʂ̒ L = ' + floatTostr(L));
  memo1.Lines.Add('S e = ' + floatTostr(e));
end;

// oȐ |`Ɛ`̖ʐ
procedure TForm1.area(bx, by, gx, gy: double);
var
  x4, s4 : double;
  v4     : double;
  s1, sl, sr   : double;
  sbl, sbr, sb : double;
  b2, b2sa2    : double;
  y0, y1       : double;
  ds, ss, s    : double;
begin
  memo1.Lines.Add('');
  by := abs(by);
  gy := abs(gy);

  // ̌vZ {̒lvZ܂
  sbl := a * b * arccosh(by / b);              // * ^ʐ
  x4 := a / b * sqrt(by * by - b * b);         // x = by , y = x4
  s4 := by * x4 - sbl;                         // |`ʐ = Opʐ - `ʐ
  if bx > 0 then begin                         // _Ɠ̏ꍇ
   s4 := -s4;
   sbl := -sbl;
  end;
  v4 := (gy - by) * bx / (gx - bx);            // ␳Op
  s1 := bx * v4;                               // ␳Opʐ
  sl := (s4 + s1);                             // ̒l

  // ĚvZ {̒lvZ܂
  sbr := a * b * arccosh(gy / b);              // * ^ʐ
  x4 := a / b * sqrt(gy * gy - b * b);         // x = gy , y = x4
  s4 := gy * x4 - sbr;                         // |`ʐ = Opʐ - `ʐ
  if gx < 0 then begin                         // _Ɠ̏ꍇ
    s4 := -s4;
    sbr := -sbr;
  end;
  v4 := (gy - by) * gx / (gx - bx);            // ␳Op
  s1 := gx * v4;                               // ␳Opʐ
  sr := (s4 - s1);                             // E̒l

  sb := (sbl + sbr) / 2;                       // * EZ̓񕪂̈
  s := (sl + sr) / 2;                          // EZ̓񕪂̈

  memo1.Lines.Add('|`̖ʐ Su = ' + floatTostr(s));
  memo1.Lines.Add('^̖ʐ So = ' + floatTostr(sb));

  // O_̒l bx,y, 0,0  gx,gy  ̖ʐ - |`ʐ
  b2 := b * b;
  b2sa2 := b * b / a / a;
  y0 := sqrt(b2 + b2sa2 * bx * bx);       // oȐbẍʒuy̒l
  y1 := sqrt(b2 + b2sa2 * gx * gx);       // oȐgẍʒuy̒l
  ds := abs(bx * y1 - gx * y0) / 2;       // Op`ʐ
  ss := ds - s;                           // `ʐ
  memo1.Lines.Add('`̖ʐ So''= ' + floatTostr(ss));
end;

// ^hԂ
procedure TForm1.archpaint(bx, by, gx, gy: double);
var
  i, n      : integer;
  dx        : double;
  dpx, dpy  : double;
  xmin, ymin    : double;
  xmax, ymax    : double;
  px0, py0      : integer;
  pxmin, pymin  : integer;
  pxmax, pymax  : integer;
  xp1, yp1      : integer;
  xp2, yp2      : integer;
  xf1, yf1      : double;
  b2, b2sa2     : double;
  xf2           : double;
begin
  ymin := Chart1.LeftAxis.Minimum;
  ymax := Chart1.LeftAxis.Maximum;
  xmin := Chart1.BottomAxis.Minimum;
  xmax := Chart1.BottomAxis.Maximum;
  if d > 0 then begin
    px0  := Series7.CalcXPos(0);
    py0  := Series7.CalcYPos(0);
  end
  else begin
    px0  := Series7.CalcXPos(2);
    py0  := Series7.CalcYPos(2);
  end;

  pxmin := Series4.CalcXPos(1);
  pymin := Series4.CalcYPos(1);
  pxmax := Series4.CalcXPos(2);
  pymax := Series4.CalcYPos(0);
  dpy   := (pymax - pymin) / (ymax - ymin);  // pymax < pymin ɒ
  dpx   := (pxmax - pxmin) / (xmax - xmin);

  b2 := b * b;
  b2sa2 := b * b / a / a;
  xf1 := dpx * bx;
  xf2 := dpx * gx;
  dx := (gx - bx) / (xf2 - xf1) * 5;
  n := round(abs(xf2 - xf1) / 5);
  Image1.Canvas.Pen.Color := clLime;
  Image1.Canvas.Pen.Style := psSolid;
  Image1.Canvas.Pen.Width := 1;
  for i:= 0 to n - 1 do begin
    xf1 := i * dx  + bx;
    yf1 := sqrt(b2 + b2sa2 * xf1 * xf1);            // oȐyl
    xp1 := round(dpx * (xf1)) + px0;
    xp2 := px0;
    if d > 0 then begin                             // oȐ+-ŌvZύX
      yp1 := py0 + round(dpy * yf1);
      yp2 := py0;
    end
    else begin
      yp1 := py0 + round(dpy * -yf1);
      yp2 := py0;
    end;
    Image1.Canvas.MoveTo(xp1, yp1);
    Image1.Canvas.LineTo(xp2, yp2);
  end;
end;

// TImageɕo
procedure TForm1.Textdraw;
var
  xpp, ypp: integer;
begin
  Image1.Canvas.Font.Size := 17;                         // ̍
  Image1.Canvas.Font.Color := clRed;
  Image1.Canvas.Font.Name := 'Tahoma';
  xpp := (Series7.CalcXPos(0) + Series7.CalcXPos(2)) div 2 - 7;   // axʒuvZ
  ypp := Series7.CalcyPos(1) - 17;                                // ayʒuvZ
  Image1.Canvas.TextOut(xpp, ypp, 'a');                           // a̕`

  xpp := Series7.CalcXPos(1) - 15;                                // bxʒuvZ
  ypp := Series7.CalcYPos(0) - ((Series7.CalcYPos(0) - Series7.CalcYPos(2)) div 2) - 15; // byʒuvZ
  Image1.Canvas.TextOut(xpp, ypp, 'b');                           // b̕`

  xpp := (Series7.CalcXPos(0) + Series7.CalcXPos(2)) div 2 - 12;  // cxʒuvZ
  ypp := Series7.CalcYPos(0) - (Series7.CalcYPos(0) - Series7.CalcYPos(2)) div 2;
  if d > 0 then  begin
    xpp := xpp + 12;
    ypp := ypp - 12;                                              // cyʒuvZ
  end
  else begin
    xpp := xpp - 12;
    ypp := ypp - 12;                                              // cyʒuvZ
  end;
  Image1.Canvas.TextOut(xpp, ypp, 'c');                           // c̕`
  if d > 0 then begin
    xpp := Series1.CalcXPos(xpL) - 20;
    ypp := Series1.CalcYPos(xpL) - 20;
    Image1.Canvas.TextOut(xpp, ypp, '');                        // ̕`

  end
  else begin
    xpp := Series3.CalcXPos(xpL) - 20;
    ypp := Series3.CalcYPos(xpL) - 20;
    Image1.Canvas.TextOut(xpp, ypp, '');                        // ̕`
  end;
  if d > 0 then begin
    xpp := Series1.CalcXPos(xpR);
    ypp := Series1.CalcYPos(xpR) - 20;
    Image1.Canvas.TextOut(xpp, ypp, '');                        // ̕`

  end
  else begin
    xpp := Series3.CalcXPos(xpR);
    ypp := Series3.CalcYPos(xpR) - 20;
    Image1.Canvas.TextOut(xpp, ypp, '');                        // ̕`
  end;
end;

// ̕`
procedure TForm1.Linedraw;
var
  i       : integer;
  xp1, yp1: integer;
  xp2, yp2: integer;
begin
  xp1 := Series7.CalcXPos(0);               // oȐ_X
  yp1 := Series7.CalcYPos(0);               // oȐ_y
  xp2 := Series7.CalcXPos(2);               // Ot_ x0
  yp2 := Series7.CalcYPos(2);               // Ot_ y0
  Image1.Canvas.Pen.Color := clBlue;
  Image1.Canvas.Pen.Width := 2;
  Image1.Canvas.Pen.Style := psSolid;
  Image1.Canvas.MoveTo(xp1,yp1);            // c ̐
  Image1.Canvas.LineTo(xp2,yp2);
  application.ProcessMessages;
  Image1.Canvas.Pen.Color := clskyblue;
  Image1.Canvas.Pen.Width := 1;
  Image1.Canvas.Pen.Style := psSolid;
  for i := xpL to xpR do begin              // oȐ|`hԂ
    if i mod 2 = 0 then begin
      if d < 0 then begin
        xp1 := Series3.CalcXPos(i);         // oȐ-yW
        yp1 := Series3.CalcYPos(i);
      end;
      if d > 0 then begin
        xp1 := Series1.CalcXPos(i);         // oȐ+yW
        yp1 := Series1.CalcYPos(i);
      end;
      xp2 := Series2.CalcXPos(i);           // W
      yp2 := Series2.CalcYPos(i);
      Image1.Canvas.MoveTo(xp1,yp1);
      Image1.Canvas.LineTo(xp2,yp2);
    end;
  end;

  Image1.Canvas.Pen.Color := clblack;
  Image1.Canvas.Pen.Width := 1;
  Image1.Canvas.Pen.Style := psDashdotdot;
  xp1 := Series4.CalcXPos(0);
  xp2 := Series4.CalcXPos(2);
  if d > 0 then
    yp1 := Series7.CalcYPos(0)              // y = 0 ̍W@
  else
    yp1 := Series7.CalcYPos(2);             // y = 0 ̍W
  yp2  := yp1;
  Image1.Canvas.MoveTo(xp1,yp1);            // X
  Image1.Canvas.LineTo(xp2,yp2);
  if d > 0 then
    xp1 := Series7.CalcXPos(0)              // x = 0 ̍W
  else
    xp1 := Series7.CalcXPos(2);             // x = 0 ̍W
  xp2 := xp1;
  yp1 := Series4.CalcYPos(0);
  yp2 := Series4.CalcYPos(1);
  Image1.Canvas.MoveTo(xp1,yp1);            // y
  Image1.Canvas.LineTo(xp2,yp2);

  if d > 0 then begin
    xp1 := Series1.CalcXPos(xpl);             // beta x
    yp1 := Series1.CalcYPos(xpl);             // beta y
  end
  else begin
    xp1 := Series3.CalcXPos(xpl);             // beta x
    yp1 := Series3.CalcYPos(xpl);             // beta y
  end;
  if d > 0 then begin
    xp2 := Series7.CalcXPos(0);               // x 0
    yp2 := Series7.CalcYPos(0);               // y 0
  end
  else begin
    xp2 := Series7.CalcXPos(2);               // x 0
    yp2 := Series7.CalcYPos(2);               // y 0
  end;
  Image1.Canvas.Pen.Style := psSolid;
  Image1.Canvas.MoveTo(xp1,yp1);            // beta x,y -> 0,0
  Image1.Canvas.LineTo(xp2,yp2);
  if d > 0 then begin
    xp1 := Series1.CalcXPos(xpR);             // gamma x
    yp1 := Series1.CalcyPos(xpR);             // gamma y
  end else begin
    xp1 := Series3.CalcXPos(xpR);             // gamma x
    yp1 := Series3.CalcyPos(xpR);             // gamma y
  end;
  Image1.Canvas.LineTo(xp1,yp1);            // 0,0 -> gamma x,y ̐
end;

// oȐ̕`
function TForm1.fy: boolean;
label
  XPOS;
const
  nk100 = 100;                              // oȐ
var
  betaX,  betaY   : double;                 // oȐƒ̌_
  gammaX, gammaY  : double;                 // oȐƒ̌_
  a0, b0, c0      : double;                 // a0x^2 + b0x + c0 = 0
  e0, f0          : double;
  i, n, k         : integer;
  dx, y, x        : double;
  Xmax, Xmin, Ymax, Ymin : double;
  asb             : double;                 // QߐXΌW
  sbF             : integer;                // QߐtO
  bx, gx          : double;
begin
  result := false;
  xpF    := false;
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.FillRect(rect(0,0,Image1.Width,Image1.Height));
  Image1.Canvas.Brush.Style := bsClear;
  chart1.BackImage.Bitmap := Image1.Picture.Bitmap;
  memo1.Clear;
  Series1.Clear;                            // oȐ+
  Series2.Clear;                            // y = a/b * x
  Series3.Clear;                            // oȐ-
  Series4.Clear;                            // XP[ݒ
  Series5.Clear;                            // Qߐ
  Series6.Clear;                            // Qߐ
  Series7.Clear;                            // abc Op

  sbF := 0;                                 // QߐtO
  betaX  := 0;
  gammaX := 0;
  betaY  := 0;
  gammaY := 0;
  bx     := 0;
  gx     := 0;
  a0     := 0;
  e0     := 0;
  if checkbox1.Checked then goto XPOS;

  // _vZ    Ả@
  a0 := 1 / a / a - alpha * alpha / b / b;
  b0 := - 2 * alpha * d / b / b;
  c0 := - d * d / b / b + 1;
  e0 := b0 * b0 - 4 * a0 * c0;
  if e0 < 0 then begin
    memo1.Lines.Add('_');
    betaX := -(a + b) / 2 * 5;
    gammaX := (a + b) / 2 * 5;
    sbF := 1;
  end
  else begin                                // oȐɌ_񂩏
    if a0 <> 0 then begin
      xpF    := true;
      f0 := sqrt(e0);
      betaX  := (- b0 - f0) / 2 / a0;
      betaY  := alpha * betax + d;
      gammaX := (- b0 + f0) / 2 / a0;
      gammaY := alpha * gammax + d;
      memo1.Lines.Add(' x, y = ' + floatTostr(betax) + ', ' + floatTostr(betay));
      memo1.Lines.Add(' x, y = ' + floatTostr(gammax) + ', ' + floatTostr(gammay));
    end;
  end;
  application.ProcessMessages;              // memo1o͂m肳܂

  if e0 = 0 then begin
    if d <> 0 then memo1.Lines.Add('ڐ');
    betaX := -(a + b);
    gammaX := (a + b);
    sbf := 2;
  end;

  if betaY * gammaY < 0 then begin
    memo1.Lines.Add('㉺oȐɑ΂钼');
    bx := betaX;
    gx := gammaX;
    x := abs(betaX);
    y := abs(gammaX);
    if x > y then begin
      betaX := -x;
      gammaX := x;
    end
    else begin
      betaX := -y;
      gammaX := y;
    end;
    if abs(betaX) < abs(a) * 2 then begin
      betaX := -abs(a) * 2;
      gammaX := abs(a) * 2;
    end;

    sbF := 3;
  end;

  if a0 = 0 then begin
    if b0 <> 0 then begin
      memo1.Lines.Add('_ꂩ Qߐƕs');
      betaX  := c0  / b0;
      betaY  := alpha * betax + d;
      memo1.Lines.Add(' x, y = ' + floatTostr(betax) + ', ' + floatTostr(betay));
      betaX := -(a + b);
      gammaX := (a + b);
    end
    else begin
      memo1.Lines.Add('_ Qߐƕs');
    end;
    sbF := 4;
  end;
XPOS:
  if checkbox1.Checked then begin
    bx    := xinp;
    gx    := xinp;
    betax := xinp;
    gammax := xinp;
    if xinp < 5 then begin
      betax := 5;
      gammax := 5;
    end;
    dx := 1 + xinp * xinp / a / a;
    y :=  sqrt(dx * b * b);
    betay := y;
    gammay := -y;
    sbF := 5;
    memo1.Lines.Add('㉺oȐɑ΂钼');
    memo1.Lines.Add(' x, y = ' + floatTostr(bx) + ', ' + floatTostr(betay));
    memo1.Lines.Add(' x, y = ' + floatTostr(gx) + ', ' + floatTostr(gammay));
  end;

  application.ProcessMessages;                // memo1o͂m肳܂
  dx := abs((gammaX - betaX) / nk100);
  xmax := gammaX * 1.5;
  xmin := betaX * 1.5;
  if abs(betaX) > abs(gammaX) then begin
    xmax := abs(betaX);
    xmin := - abs(betaX) * 1.5;
  end;
  if abs(betaX) < abs(gammaX) then begin
    xmax := abs(gammaX) * 1.5;
    xmin := - abs(gammaX);
  end;
  if abs(betaX) = abs(gammaX) then begin
    xmax := abs(gammaX) * 1.5;
    xmin := - abs(betaX) * 1.5;
  end;
  xpl := 0;
  xpR := 0;
  if dx <> 0 then n := round((xmax - xmin) / dx)
             else begin
                n := nk100;
                dx := (xmax - xmin) / n
             end;
  asb := b / a;
  for i := 0 to n do begin
    x := i * dx + xmin;
    if x < betaX  then xpL := i;
    if x < gammaX then xpR := i;
    y := sqrt((1+ x * x / a / a) * b * b);    // oȐyvZ
    if a0 <> 0 then begin
      if (betay > 0) and (gammay > 0) then Series1.AddXY(x, y);   // +oȐ
      if (betay < 0) and (gammay < 0) then Series3.AddXY(x, -y);  // -oȐ
      if (betay * gammay < 0) then begin
        Series1.AddXY(x, y);                            // +oȐ
        Series3.AddXY(x, -y);                           // -oȐ
      end;
    end;
    if (a0 = 0) or (e0 < 0) then begin
      Series1.AddXY(x, y);                              // +oȐ
      Series3.AddXY(x, -y);                             // -oȐ
    end;
    y := asb * x;
    if sbF = 0 then begin
      if d > 0 then begin
        if x > -a then Series5.AddXY(x, y);             // +Qߐ
      end
      else if x < a then Series5.AddXY(x, y);
    end
    else Series5.AddXY(x, y);

    y := -asb * x;
    if sbF = 0 then begin
      if d > 0 then begin
        if x <  a then Series6.AddXY(x, y);             // -Qߐ
      end
      else if x >  -a then Series6.AddXY(x, y);
    end
    else Series6.AddXY(x, y);
  end;
  Chart1.Update;
  application.ProcessMessages;                          // Oto͂m肳܂
  ymin := Chart1.LeftAxis.Minimum;
  ymax := Chart1.LeftAxis.Maximum;
  k := 0;
  if not checkbox1.Checked then begin
    for i := 0 to n do begin
      x := i * dx + xmin;
      y := alpha * x + d;                                 // yvZ
      if (y <= ymax * 1.5) and (y >= ymin * 1.5) then begin
        Series2.AddXY(x, y);                                // 
        inc(k);
      end;
    end;
  end;
  if k < 3 then begin
    Series2.Clear;
    Series2.AddXY(bx, ymin * 1.5);                                // 
    Series2.AddXY(gx, ymax * 1.5);                                // 
  end;
  Chart1.Update;
  application.ProcessMessages;                          // Oto͂m肳܂
  xmin := Chart1.BottomAxis.Minimum;
  xmax := Chart1.BottomAxis.Maximum;
  ymin := Chart1.LeftAxis.Minimum;
  ymax := Chart1.LeftAxis.Maximum;
  if (xmax - xmin) > (ymax - ymin) then begin
    dx := ((xmax - xmin) - (ymax - ymin)) / 2;
    ymin := ymin - dx;
    ymax := ymax + dx;
  end
  else begin
    dx := ((ymax - ymin) - (xmax - xmin)) / 2;
    xmin := xmin - dx;
    xmax := xmax + dx;
  end;

  Series4.AddXY(xmin, ymax);                            // XP[ݒ
  Series4.AddXY(xmin, ymin);
  Series4.AddXY(xmax, ymin);
  Chart1.Update;
  application.ProcessMessages;                          // Oto͂m肳܂

  if sbF <> 0 then exit;
  if d > 0 then begin
    Series7.AddXY(0, 0);                                  // ԏl
    Series7.AddXY(0, b);                                  // b̐
    Series7.AddXY(a, b);                                  // a̐
  end
  else begin
    Series7.AddXY(-a, -b);                                // ԏl
    Series7.AddXY(0, -b);                                 // a̐
    Series7.AddXY(0, 0);                                  // b̐
  end;
  application.ProcessMessages;                          // Oto͂m肳܂

  archpaint(betaX, betaY, gammaX, gammaY);
  Linedraw;
  Textdraw;
  integral(betaX, gammaX);
  area(betaX, betaY, gammaX, gammaY);
  arch(betaX, gammaX, betaY, gammaY);
  chart1.BackImage.Bitmap := Image1.Picture.Bitmap;
end;

// oȐ}
procedure TForm1.Image2Draw;
begin
  Image2.Canvas.Brush.Color := clBtnFace;
  Image2.Canvas.Brush.Style := bsSolid;
  Image2.Canvas.FillRect(rect(0, 0, Image2.Width, Image2.Height));
  Image2.Canvas.Font.Name := 'MS UI Gothic';
  Image2.Canvas.Font.Style := [fsItalic, fsBold];
  Image2.Canvas.Font.Size := 12;
  Image2.Canvas.Pen.Color := clBlack;
  Image2.Canvas.Pen.Width := 2;
  Image2.Canvas.Brush.Style := bsClear;
  Image2.Canvas.Pen.Style := psSolid;
  Image2.Canvas.MoveTo(20, 37);
  Image2.Canvas.LineTo(45, 37);
  Image2.Canvas.TextOut(25, 16, 'x');
  Image2.Canvas.TextOut(25, 38, 'a');
  Image2.Canvas.MoveTo(20 + 45, 37);
  Image2.Canvas.LineTo(45 + 45, 37);
  Image2.Canvas.TextOut(25 + 45, 16, 'y');
  Image2.Canvas.TextOut(25 + 45, 38, 'b');
  Image2.Canvas.Font.Size := 10;
  Image2.Canvas.TextOut(34, 16, '2');
  Image2.Canvas.TextOut(34, 38, '2');
  Image2.Canvas.TextOut(34 + 45, 16, '2');
  Image2.Canvas.TextOut(34 + 45, 38, '2');
  Image2.Canvas.Font.Size := 13;
  Image2.Canvas.TextOut(50, 29, '-');
  Image2.Canvas.TextOut(100, 29, '= -1');
  Image2.Canvas.TextOut(240, 29, 'y = x + c');
  Image2.Canvas.Font.Size := 11;
  Image2.Canvas.Font.Style := [fsBold];
  Image2.Canvas.TextOut(50, 2, 'oȐ');
  Image2.Canvas.TextOut(250, 2, '');
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  bm : Tbitmap;
begin
  bm := Tbitmap.Create;
  bm.Width := Chart1.Width;
  bm.Height := Chart1.Height;
  Image1.Width := Chart1.Width;
  Image1.Height := Chart1.Height;
  Image1.Visible := False;
  Image1.Picture.Bitmap := bm;
  Image1.Canvas.Brush.Color := clWhite;
  bm.Width := Image2.Width;
  bm.height := Image2.Height;
  Image2.Picture.Bitmap := bm;
  bm.Free;
  Image2Draw;
end;

end.
